using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Tracing
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtCustomerName;
		private System.Windows.Forms.TextBox txtCreditLimit;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button cmdUpdateCreditLimit;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtCustomerName = new System.Windows.Forms.TextBox();
			this.txtCreditLimit = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.cmdUpdateCreditLimit = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// txtCustomerName
			// 
			this.txtCustomerName.Location = new System.Drawing.Point(152, 32);
			this.txtCustomerName.Name = "txtCustomerName";
			this.txtCustomerName.Size = new System.Drawing.Size(264, 29);
			this.txtCustomerName.TabIndex = 0;
			this.txtCustomerName.Text = "Jim Bag";
			// 
			// txtCreditLimit
			// 
			this.txtCreditLimit.Location = new System.Drawing.Point(152, 80);
			this.txtCreditLimit.Name = "txtCreditLimit";
			this.txtCreditLimit.Size = new System.Drawing.Size(264, 29);
			this.txtCreditLimit.TabIndex = 1;
			this.txtCreditLimit.Text = "10000.00";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(32, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 32);
			this.label1.TabIndex = 2;
			this.label1.Text = "name:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(32, 80);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 32);
			this.label2.TabIndex = 3;
			this.label2.Text = "credit limit:";
			// 
			// cmdUpdateCreditLimit
			// 
			this.cmdUpdateCreditLimit.Location = new System.Drawing.Point(64, 152);
			this.cmdUpdateCreditLimit.Name = "cmdUpdateCreditLimit";
			this.cmdUpdateCreditLimit.Size = new System.Drawing.Size(320, 48);
			this.cmdUpdateCreditLimit.TabIndex = 4;
			this.cmdUpdateCreditLimit.Text = "Update Credit Limit";
			this.cmdUpdateCreditLimit.Click += new System.EventHandler(this.cmdUpdateCreditLimit_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(10, 22);
			this.ClientSize = new System.Drawing.Size(456, 264);
			this.Controls.Add(this.cmdUpdateCreditLimit);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.txtCreditLimit);
			this.Controls.Add(this.txtCustomerName);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Customer App (simulated)";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// when app starts, delete the previous log file (if any)
			string  logfile = System.AppDomain.CurrentDomain.BaseDirectory + "AppLog.txt";
			System.IO.TextWriter  log = new System.IO.StreamWriter(logfile);

			if (Globals.Trace)  // then also send trace output to log file
			{
				System.Diagnostics.TextWriterTraceListener  logger;
				logger = new System.Diagnostics.TextWriterTraceListener(log);
				System.Diagnostics.Trace.Listeners.Add(logger);
				System.Diagnostics.Trace.WriteLine("App starting: " + DateTime.Now);
			}

			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void cmdUpdateCreditLimit_Click(object sender, System.EventArgs e)
		{
			DataAccess  datatier = null;

			try
			{
				datatier = new DataAccess();
				datatier.Open();
				datatier.UpdateCreditLimit(this.txtCustomerName.Text, decimal.Parse(this.txtCreditLimit.Text));
			}
			catch(Exception ex)
			{
				MessageBox.Show("Updated failed (" + ex.Message + ").");
			}
			finally
			{
				if (datatier != null)
					datatier.Close();
			}
		}
	}
}
